
use master
go
drop database simple
go

create database simple
go
alter database simple add filegroup simple_mod contains memory_optimized_data
go
-- adapt filename as needed
alter database simple add file (name='simple_mod', filename='c:\data\simple_mod') to filegroup simple_mod
go

use simple
go

drop sequence seq1
drop table txtest

create table txtest (
 id int NOT NULL primary key NONCLUSTERED HASH WITH (BUCKET_COUNT = 50000),
 [c1] int NOT NULL
)WITH ( MEMORY_OPTIMIZED = ON , DURABILITY = SCHEMA_AND_DATA )

create sequence seq1 as int start with 0;

set nocount on
go
-- takes about a minute
insert txtest values(next value for seq1, next value for seq1)
go 200000

checkpoint
go

-- do 200 of these on 5 threads using SQLQueryStress
begin tran
select top(150000) * from txtest with (serializable)
update txtest with (serializable)  set c1 = 1  
where c1 in (select top(10) c1 from txtest with (serializable) order by newid())
commit

begin tran
select top(50000) * from txtest with (serializable) order by newid()
insert txtest values(next value for seq1, next value for seq1)
insert txtest values(next value for seq1, next value for seq1)
--update txtest with (serializable)  set c1 = 1  
--where c1 in (select top(3) c1 from txtest with (serializable) order by newid())
select top(40000) * from txtest with (serializable) order by newid()
commit

create table txtest_disk (
 id int NOT NULL primary key NONCLUSTERED,
 [c1] int NOT NULL
)

select top(150000) * from txtest_disk
update txtest_disk  set c1 = 1  
where c1 in (select top(10) c1 from txtest_disk order by newid())

set nocount on
insert txtest_disk values(next value for seq1, next value for seq1)
go 200000



