
use simple2
go

-- empty memopt db (0.6094, 0.0628)
select * from sys.dm_db_xtp_memory_consumers
select cast(cast(sum(allocated_bytes) as decimal(12,4))/(1024*1024) as decimal(12,4)) as 'allocated(MB)',
       cast(cast(sum(used_bytes) as decimal(12,4))/(1024*1024) as decimal(12,4)) as 'used(MB)'
from sys.dm_db_xtp_memory_consumers

create type samptype as table (id int not null PRIMARY KEY NONCLUSTERED, 
                               name nchar(450) COLLATE Latin1_General_BIN2 not null INDEX idx2 nonclustered) WITH (MEMORY_OPTIMIZED=ON);

create type samptype2 as table (id int not null PRIMARY KEY NONCLUSTERED hash( id ) with( bucket_count = 131072), 
                               name nchar(450) COLLATE Latin1_General_BIN2 not null) WITH (MEMORY_OPTIMIZED=ON);


-- after create type (0.6094, 0.0631)
select * from sys.dm_db_xtp_memory_consumers
select cast(cast(sum(allocated_bytes) as decimal(14,4))/(1024*1024) as decimal(14,4)) as 'allocated(MB)',
       cast(cast(sum(used_bytes) as decimal(14,4))/(1024*1024) as decimal(14,4)) as 'used(MB)'
from sys.dm_db_xtp_memory_consumers

select * from sys.dm_db_xtp_table_memory_stats


-- during this batch, PGPOOL goes to 380mb allocated/used then 456mb allocated/used
-- at end of batch, PGPOOL goes to 62mb allocated/0 used
declare @t samptype2;
declare @i int = 1
while (@i <= 360000)
  begin
  insert @t values (@i, replicate('a', 450));
  set @i = @i + 1;
  end
--select * from @t
waitfor delay '00:02:00'

select * from sys.dm_db_xtp_memory_consumers
select cast(cast(sum(allocated_bytes) as decimal(16,4))/(1024*1024) as decimal(16,4)) as 'allocated(MB)',
       cast(cast(sum(used_bytes) as decimal(16,4))/(1024*1024) as decimal(16,4)) as 'used(MB)'
from sys.dm_db_xtp_memory_consumers
where memory_consumer_type_desc = 'PGPOOL'