
select s.name as schemaname, t.* 
from sys.tables t
join sys.schemas s 
  on t.schema_id = s.schema_id
where t.name like '%inmem'

-- no rows in this table
select * 
from Sales.SalesOrderHeader_inmem h
join Sales.SalesOrderDetail_inmem d
  on h.SalesOrderID = d.SalesOrderID;

select * 
from Sales.SpecialOffer_inmem o 
join Sales.SpecialOfferProduct_inmem op
on o.SpecialOfferID = op.SpecialOfferID
join Production.Product_inmem p
on op.ProductID = p.ProductID;

CREATE PROCEDURE Sales.usp_GetSpecialOrderInfo_inmem
WITH NATIVE_COMPILATION, SCHEMABINDING, EXECUTE AS OWNER
AS
BEGIN ATOMIC WITH
  (TRANSACTION ISOLATION LEVEL = SNAPSHOT,
   LANGUAGE = N'us_english')
select o.SpecialOfferID, o.Description, op.ProductID, p.Name, p.ProductNumber  
from Sales.SpecialOffer_inmem o 
join Sales.SpecialOfferProduct_inmem op
on o.SpecialOfferID = op.SpecialOfferID
join Production.Product_inmem p
on op.ProductID = p.ProductID;
END

exec Sales.usp_GetSpecialOrderInfo_inmem

-- enable statistics collection
-- this slows the procedures down
/*
EXEC sys.sp_xtp_control_proc_exec_stats
 @collectionvalue = value | @collectionstatus = value
EXEC sys.sp_xtp_control_query_exec_stats
 @collectionvalue = value[,@database_id = = database_id , @xtp_object_id =  procedure_id ]
*/



