
-- restore
-- When you restore a database with NORECOVERY causes the database to be created 
-- and the disk image restored without consuming any In-Memory OLTP memory.
RESTORE DATABASE Hekaton_DB 
   FROM DISK = 'C:\hekaton_test\hekaton_DB.bak'
 , NORECOVERY

-- Create the resource pool
CREATE RESOURCE POOL Pool_Hekaton WITH (MAX_MEMORY_PERCENT = 50);
ALTER RESOURCE GOVERNOR RECONFIGURE;
GO

-- Bind the database and resource pool
EXEC sp_xtp_bind_db_resource_pool 'Hekaton_DB', 'Pool_Hekaton'
GO

--Restore with RECOVERY
--When you restore the database with recovery the database is brought online and all the data restored.
RESTORE DATABASE Hekaton_DB 
   FROM DISK = 'C:\hekaton_test\Hekaton_DB.bak'
 , RECOVERY
