
use adventureworks2012
go

-- Database-level XTP DMVs
-- Table, index, memory DMVs
select * from sys.dm_db_xtp_hash_index_stats -- 7 rows bucket_count, empty_bucket_count, avg/max_chain_len
select * from sys.dm_db_xtp_index_stats -- 22 rows, object id for idx and object_ids -2 to -8 - scans, rows, phantom_scans, etc
select * from sys.dm_db_xtp_memory_consumers -- 29 rows, memory consumer_desc, consumer_type, object_id, index_id, alloc'd bytes, etc -- includes tables and -2 to -7, 0, and NULL
select * from sys.dm_db_xtp_nonclustered_index_stats -- 5 rows 
select * from sys.dm_db_xtp_object_stats -- 14 rows, includes tables and -2 to -8, rows_insert/update/delete and conflicts -- **undocumented
select * from sys.dm_db_xtp_table_memory_stats -- 14 rows, includes tables and -2 to -8, memory alloc/used for table/indexes

-- Checkpoint
-- ~20 rows
select * from sys.dm_db_xtp_checkpoint_files -- info about xtp files (ROOT, DELTA, DATA)
-- 1 row
select * from sys.dm_db_xtp_checkpoint_stats -- one for each checkpoint

-- GC, Merge, Transactions
select * from sys.dm_db_xtp_gc_cycle_stats -- Up to 135 rows (Ring buffer of recent GCs)
select * from sys.dm_db_xtp_merge_requests -- 1, status 'installed'
select * from sys.dm_db_xtp_transactions -- 2 rows, for each transaction -- refers to read_set, write_set, scan_set -- includes up to 8 dependent_addresses

select * from sys.internal_tables
where name = 'xtp_storage' -- xtp_storage object_id 245575913

-- Instance-level XTP DMVs
select * from sys.dm_xtp_gc_queue_stats -- 2 rows, 2 queues id 0 and 1
select * from sys.dm_xtp_gc_stats -- 1 row, rows_examined, rows_no_sweep_needed, etc (1 row)
select * from sys.dm_xtp_system_memory_consumers -- 23 rows, consumer memory id 1-23, allocated_bytes, min/max_sizeclass etc
select * from sys.dm_xtp_threads -- GC MAIN and 1 USER -- retired row_count, retired_tx_count **undocumented
select * from sys.dm_xtp_transaction_recent_rows  -- empty -- row, tables, before_begin, before_end, outcome, etc **undocumented
select * from sys.dm_xtp_transaction_stats -- 1 row, total count, read_only_count, aborts, user_aborts, etc

-- New system XTP stored procedures
-- ensure stats not on
declare @c bit
exec sp_xtp_control_proc_exec_stats @new_collection_value = 0
exec sp_xtp_control_proc_exec_stats @old_collection_value=@c output
select @c as 'collection status for proc stats'

exec [sys].[sp_xtp_control_query_exec_stats]  @new_collection_value = 0
exec sp_xtp_control_query_exec_stats @old_collection_value=@c output
select @c as 'collection status for query stats'

exec sys.sp_xtp_bind_db_resource_pool N'MyDB', N'MyPool'
exec sys.sp_xtp_unbind_db_resource_pool  N'MyDB'
exec sys.sp_xtp_checkpoint_force_garbage_collection -- affects checkpoint files only

select * from sys.fn_dblog_xtp(NULL, NULL)
select * from sys.fn_dump_dblog_xtp(NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL)



