use AdventureWorksDW2012
go

-- Make copy of fact reseller table
SELECT * INTO dbo.FactResellerSales_cci FROM dbo.FactResellerSales;
GO

-- Note no keylist
CREATE CLUSTERED COLUMNSTORE INDEX CCI_FactResellerSales
ON dbo.FactResellerSales_cci;
GO

SET STATISTICS IO ON;
SET STATISTICS TIME ON;
GO

-- Select from table with row store
SELECT f.EmployeeKey, SUM(f.SalesAmount) AS [TotalSales]
FROM dbo.FactResellerSales AS f
INNER JOIN dbo.DimProduct AS d1 ON f.ProductKey = d1.ProductKey
INNER JOIN dbo.DimEmployee AS d2 ON f.EmployeeKey = d2.EmployeeKey
GROUP BY f.EmployeeKey;
  
-- Select from table with column store
SELECT f.EmployeeKey, SUM(f.SalesAmount) AS [TotalSales]
FROM dbo.FactResellerSales_cci AS f
INNER JOIN dbo.DimProduct AS d1 ON f.ProductKey = d1.ProductKey
INNER JOIN dbo.DimEmployee AS d2 ON f.EmployeeKey = d2.EmployeeKey
GROUP BY f.EmployeeKey;

SET STATISTICS IO OFF;
SET STATISTICS TIME OFF;

DROP TABLE dbo.FactResellerSales_cci
GO