
USE AdventureWorksDW2012;
GO
CREATE TABLE dbo.FactInternetSales2 (
    ProductKey [int] NOT NULL, 
    OrderDateKey [int] NOT NULL, 
    DueDateKey [int] NOT NULL, 
    ShipDateKey [int] NOT NULL);

CREATE CLUSTERED COLUMNSTORE INDEX cci_FactInternetSales2
ON dbo.FactInternetSales2;

INSERT INTO dbo.FactInternetSales2
SELECT ProductKey, OrderDateKey, DueDateKey, ShipDateKey
FROM dbo.FactInternetSales;

SELECT * FROM sys.column_store_row_groups;

-- The results of the show there is one OPEN rowgroup, which means SQL Server will wait for more rows 
-- to be added before it closes the rowgroup and moves the data to the columnstore. 
-- This next statement rebuilds the clustered columnstore index.

ALTER INDEX cci_FactInternetSales2 ON FactInternetSales2 REBUILD;
SELECT * FROM sys.column_store_row_groups;

-- The results of the SELECT statement show the rowgroup is COMPRESSED, 
-- which means the column segments of the rowgroup are now compressed and stored in the columnstore. 

DROP TABLE FactInternetSales2
GO

CREATE TABLE dbo.FactInternetSales2 (
    ProductKey [int] NOT NULL, 
    OrderDateKey [int] NOT NULL, 
    DueDateKey [int] NOT NULL, 
    ShipDateKey [int] NOT NULL);

CREATE CLUSTERED COLUMNSTORE INDEX cci_FactInternetSales2
ON dbo.FactInternetSales2;

-- Insert 300,000 rows
INSERT INTO dbo.FactInternetSales2
SELECT ProductKey, OrderDateKey, DueDateKey, ShipDateKey
FROM [AdventureWorksDW2008R2].dbo.FactInternetSalesNewCCI;

SELECT * FROM sys.column_store_row_groups;