
use AdventureWorks2012  -- use the right database to resolve object_ids
go

WITH xEvents AS
(SELECT object_name AS xEventName,
CAST (event_data AS xml) AS xEventData
FROM sys.fn_xe_file_target_read_file
('C:\Temp\TracesAll\Cardinality*.xel', NULL, NULL, NULL)), -- XEvent session should have file target, change to represent your location
cEvents AS
(SELECT xEventData.value('(/event/action[@name="sql_text"]/value)[1]','varchar(max)') SQLStatement,
xEventData.value('(/event/data[@name="stats_collection_id"]/value)[1]','bigint') StatsCollectionID,
xEventData.query('(/event/data[@name="input_relation"]/value/*)[1]') InputRelation,
xEventData.query('(/event/data[@name="calculator"]/value/*)[1]') Calculator,
xEventData.query('(/event/data[@name="stats_collection"]/value/*)[1]') StatsCollection,
xEventData as EntireEvent
FROM xEvents
)

SELECT * FROM
(
SELECT 
SQLStatement, StatsCollectionID,

-- fields from InputRelation
InputRelation.value('(/Operator/@Name)[1]','varchar(60)') OperatorName,
InputRelation.value('(/Operator/StatsCollection)[1]/@TableName','varchar(60)') TableName1,
InputRelation.value('(/Operator/StatsCollection)[1]/@Card','decimal(14,3)') Cardinality1,
InputRelation.value('(/Operator/StatsCollection)[2]/@TableName','varchar(60)') TableName2,
InputRelation.value('(/Operator/StatsCollection)[2]/@Card','decimal(14,3)') Cardinality2,
InputRelation.value('(/Operator/StatsCollection)[3]/@TableName','varchar(60)') TableName3,
InputRelation.value('(/Operator/StatsCollection)[3]/@Card','decimal(14,3)') Cardinality3,
-- add more fields from InputRelation here
InputRelation, Calculator, StatsCollection, EntireEvent
FROM cEvents
) as x
where Cardinality3 is not null
--order by OperatorName
;


---- fields from Calculator
--Calculator.value('local-name((/CalculatorList/*)[1])','varchar(60)') CalculatorType,
--Calculator.value('(/CalculatorList/*/@CalculatorName)[1]','varchar(60)') CalculatorName,
----Calculator.value('(/CalculatorList/*/@Role)[1]','varchar(60)') CalculatorRole,
--Calculator.value('(/CalculatorList/*/SubCalculator/*/@CalculatorName)[1]','varchar(60)') SubCalculatorName1,
--Calculator.value('(/CalculatorList/*/SubCalculator/@Role)[1]','varchar(60)') SubCalculatorRole1,
--Calculator.value('(/CalculatorList/*/SubCalculator/*/@CalculatorName)[2]','varchar(60)') SubCalculatorName2,
--Calculator.value('(/CalculatorList/*/SubCalculator/@Role)[2]','varchar(60)') SubCalculatorRole2,
--Calculator.value('(/CalculatorList/*/SubCalculator/*/@CalculatorName)[3]','varchar(60)') SubCalculatorName3,
----Calculator.value('(/CalculatorList/*/SubCalculator/@Role)[3]','varchar(60)') SubCalculatorRole3,
----Calculator.value('local-name((/CalculatorList/*/SubCalculator/*)[1])','varchar(60)') SubCalculatorType,
---- join calculator type only, should have coverage for other calculators
--Calculator.value('(/CalculatorList/*/@Selectivity)[1]','decimal(14,3)') Selectivity,
---- DistinctCount Calculator type without subcalculator only
--Calculator.value('(/CalculatorList/*/@CoveringStatDensity)[1]','decimal(14,3)') CoveringStatDensity,

----fields from Stats_Collection
--StatsCollection.value('(/StatsCollection/@Name)[1]', 'varchar(60)') StatsCollectionName,
--StatsCollection.value('(/StatsCollection/@Card)[1]', 'varchar(60)') StatsCollectionCardinality,
--OBJECT_NAME(StatsCollection.value('(/StatsCollection/LoadedStats/StatsInfo)[1]/@ObjectId', 'int')) StatsInfoObject1,
--StatsCollection.value('(/StatsCollection/LoadedStats/StatsInfo)[1]/@StatsId', 'int') StatsId1,
--OBJECT_NAME(StatsCollection.value('(/StatsCollection/LoadedStats/StatsInfo)[2]/@ObjectId', 'int')) StatsInfoObject2,
--StatsCollection.value('(/StatsCollection/LoadedStats/StatsInfo)[2]/@StatsId', 'int') StatsId2,
