
-- query_cardinality events in SQL Server 2014 CTP2
-- Bob Beauchemin, SQLskills

DBCC FREEPROCCACHE -- or use OPTION(RECOMPILE) to make sure you produce a plan

use Northwind  -- make sure Northwind database is at Compatibility Level 120 or they'll be no events
go

--Order Review
-- Five table join
SELECT Orders.[OrderID], Orders.[OrderDate], Orders.[RequiredDate], Orders.[ShippedDate], Orders.[CustomerID], 
  Customers.[CompanyName], Employees.[LastName], Shippers.[CompanyName] AS [Ship Via], [Order Subtotals].Subtotal, Orders.Freight, 
  [Subtotal]+[Freight] AS Total
FROM Employees INNER JOIN 
(Shippers INNER JOIN 
(Customers INNER JOIN 
([Order Subtotals] -- view with group order details by orderid
 INNER JOIN Orders ON [Order Subtotals].[OrderID] = Orders.[OrderID]) 
 ON Customers.[CustomerID] = Orders.[CustomerID]) 
 ON Shippers.[ShipperID] = Orders.[ShipVia]) 
 ON Employees.[EmployeeID] = Orders.[EmployeeID]
ORDER BY Orders.[OrderID] DESC;