
-- query_cardinality events in SQL Server 2014 CTP2
-- Bob Beauchemin, SQLskills

use Northwind -- use the right database to resolve object_ids if you need to
go

WITH xEvents AS
(SELECT object_name AS xEventName,
CAST (event_data AS xml) AS xEventData
FROM sys.fn_xe_file_target_read_file
('C:\Temp\Cardinality_0*.xel', NULL, NULL, NULL)), -- XEvent session should have file target, change to represent your location
cEvents AS
(SELECT xEventData.value('(/event/action[@name="sql_text"]/value)[1]','varchar(max)') SQLStatement,
xEventData.value('(/event/data[@name="stats_collection_id"]/value)[1]','bigint') StatsCollectionID,
xEventData.query('(/event/data[@name="input_relation"]/value/*)[1]') InputRelation,
xEventData.query('(/event/data[@name="calculator"]/value/*)[1]') Calculator,
xEventData.query('(/event/data[@name="stats_collection"]/value/*)[1]') StatsCollection,
xEventData as EntireEvent
FROM xEvents
)

SELECT * FROM  -- extra subselect to use with where clauses
(
SELECT 
SQLStatement, StatsCollectionID,

-- fields from InputRelation
InputRelation.value('(/Operator/@Name)[1]','varchar(60)') OperatorName,
-- fields from the InputRelations's StatsCollection(s)
InputRelation.value('(/Operator/StatsCollection)[1]/@Name','varchar(60)') InputStatsName1,
InputRelation.value('(/Operator/StatsCollection)[1]/@TableName','varchar(60)') TableName1,
InputRelation.value('(/Operator/StatsCollection)[1]/@Card','decimal(16,3)') Cardinality1,
InputRelation.value('(/Operator/StatsCollection)[2]/@Name','varchar(60)') InputStatsName2,
InputRelation.value('(/Operator/StatsCollection)[2]/@TableName','varchar(60)') TableName2,
InputRelation.value('(/Operator/StatsCollection)[2]/@Card','decimal(16,3)') Cardinality2,

-- fields from StatsCollection event field
StatsCollection.value('(/StatsCollection/@Name)[1]', 'varchar(60)') StatsCollectionName,
StatsCollection.value('(/StatsCollection/@Card)[1]', 'decimal(16,3)') StatsCollectionCardinality,

InputRelation, Calculator, StatsCollection, EntireEvent
FROM cEvents
) as x;

