

 CREATE DATABASE TestDB
 ON  PRIMARY
( NAME = N'TestDB', FILENAME = N'T:\Data\TestDB_data.mdf')
 LOG ON
( NAME = N'TestDB_log', FILENAME = N'T:\Data\TestDB_log.ldf')
GO

-- Disable delayed durability database-wide (although it is disabled by default)
ALTER DATABASE TestDB SET DELAYED_DURABILITY = DISABLED
GO

USE TestDB
GO
CREATE TABLE t1 (
id INT IDENTITY (1,1),
currtime DATETIME)
GO

--In perfmon, monitor Transactions/sec and Log Bytes Flushed/sec.
BEGIN TRAN
INSERT INTO t1 (currtime) SELECT getdate() -- Transaction commit and log flush happen simultaneously 
GO

USE master
GO
-- Allow using delayed durability
ALTER DATABASE TestDB SET DELAYED_DURABILITY = ALLOWED WITH NO_WAIT
GO 

BEGIN TRAN
INSERT INTO t1 (currtime) SELECT getdate()
COMMIT WITH (DELAYED_DURABILITY=ON) -- Transaction, but no log flush

-- To harden that log buffer to disk, run tx without delayed durability or use sp_flush_log
 EXEC sp_flush_log 




