
USE [master]
GO
-- Create the Database Master Key if it doesn't already exist
CREATE MASTER KEY ENCRYPTION BY
PASSWORD = 'StrongPW1!'
GO

-- Create the server certificate in master database
-- Encrypted with database master key
CREATE CERTIFICATE [CertificateForBackup]
WITH SUBJECT = 'Certificate for backup';
GO

BACKUP DATABASE [AdventureWorks2012] TO DISK = N'T:\Local Backups\AdventureWorks2012_full.bak'
WITH COMPRESSION
-- or use asymmetric key and asymmetric key clause here
,ENCRYPTION (ALGORITHM = AES_256 ,SERVER CERTIFICATE = CertifcateForBackup)
,STATS = 10
GO