
-- On Windows Azure storage
-- create a policy
-- create a Shared Access Key (SAS key)

/* Books online is unclear, here's what they say 
-- Create a credential
CREATE CREDENTIAL [https://testdb.blob.core.windows.net/data]
WITH IDENTITY='your policy name', -- NO
SECRET = 'your SAS key'
The IDENTITY should not be the name of the policy as the example in BOL indicates

CREATE CREDENTIAL [http://bbeauch.blob.core.windows.net/sqldata]
WITH IDENTITY='sqlserver_pol',
SECRET = 'http://bbeauch.blob.core.windows.net/sqldata?sr=c&si=sqlserver_pol&sig=8e4tVQqyL1eMtt9SRRy' -- not the URL, only the portion after '?'
*/

-- Note: Not a real key
-- SAS key generated
-- sv=2012-02-12&sr=c&si=sqls&sig=nNhbnDgIs2Vb%2F9ELM78mGOq

-- Create database with data and log files in Windows Azure container.
CREATE DATABASE testdb 
ON
( NAME = testdb_dat,
    FILENAME = 'https://testdb.blob.core.windows.net/data/TestData.mdf' )
 LOG ON
( NAME = testdb_log,
    FILENAME =  'https://testdb.blob.core.windows.net/data/TestLog.ldf') 

DROP CREDENTIAL [https://bbeauch.blob.core.windows.net/sqld]
GO

CREATE CREDENTIAL [https://bbeauch.blob.core.windows.net/sqld] -- this name should match the container path and it must start with https. 
   WITH IDENTITY='SHARED ACCESS SIGNATURE', -- this is a mandatory string. 
   SECRET = 'sv=2012-02-12&sr=c&si=sqls&sig=nNhbnDgIs2Vb%2F9ELM78mGOqYrka%2Fn0x6QqQOeYhII%2Fw%3D' -- this is the shared access signature key that you obtained in Lesson 2. 
GO  

select * from sys.credentials

-- Create database with data and log files in Windows Azure container.
CREATE DATABASE testdb 
ON
( NAME = testdb_dat,
    FILENAME = 'https://bbeauch.blob.core.windows.net/sqld/TestData.mdf')
 LOG ON
( NAME = testdb_log,
    FILENAME = 'https://bbeauch.blob.core.windows.net/sqld/TestLog.ldf');
GO


use testdb
go

create table t1 (id int primary key)
insert t1 values(1),(2),(3),(4);
select * from t1;
go

drop database testdb;